#!/usr/bin/env node
"use strict";

require("source-map-support/register");

var _commander = require("commander");

var _package = _interopRequireDefault(require("../package.json"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _isString = _interopRequireDefault(require("lodash/isString"));

var _isNumber = _interopRequireDefault(require("lodash/isNumber"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const program = new _commander.Command();
program.version(_package.default.version, '-v, --version');
program.command('run <file>').action(function (file) {
  let runFile;

  if (file.startsWith('.')) {
    runFile = _path.default.join(process.cwd(), file);
  } else {
    runFile = file;
  }

  let options = require(runFile);

  delete options.default;

  let extname = _path.default.extname(runFile);

  if (['.json', '.js'].includes(extname)) {
    if ((0, _isString.default)(options.cwd) && options.cwd.startsWith('.')) {
      options.cwd = _path.default.join(_path.default.dirname(runFile), options.cwd);
    } else {
      options.cwd = _path.default.dirname(runFile);
    }

    if (!options.env) {
      options.env = _path.default.basename(runFile, extname);
    }

    const app = require('./index');

    app(options);
  }
});
program.command('link <src> <target>').action(async (src, target, options) => {
  let _src = _path.default.join(process.cwd(), src);

  if (_fs.default.existsSync(_src)) {
    let _target = _path.default.join(process.cwd(), target);

    if (_fs.default.existsSync(_target)) {
      let stat = _fs.default.lstatSync(_target);

      if (stat.isSymbolicLink(_target)) {
        _fs.default.unlinkSync(_target);
      }
    }

    _fs.default.symlinkSync(_src, _target);

    console.log(_src, '->', target);
  }
});
program.parse(process.argv);