"use strict";

var _cluster = _interopRequireDefault(require("cluster"));

var _fs = _interopRequireDefault(require("fs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const handlers = {};
const cache = {};

function watcher(filename) {
  return function () {
    let module = require.cache[filename];

    if (module) {
      jinghuanjs.logger.info(`${_cluster.default.isMaster ? '[Master]' : '[Worker]'} delete ${filename}`);

      if (module.parent) {
        module.parent.children.splice(module.parent.children.indexOf(module), 1);
      }

      delete require.cache[filename];
      cache[filename] = require(filename);
    }
  };
}

module.exports = function HotRequire(__filename) {
  if (!handlers[__filename]) {
    handlers[__filename] = watcher(__filename);

    _fs.default.watch(__filename, handlers[__filename]);
  }

  cache[__filename] = require(__filename);
  return new Proxy(cache[__filename], {
    get: function (obj, prop) {
      return cache[__filename][prop];
    },
    set: function (obj, prop, value) {
      cache[__filename][prop] = value;
    },

    has(target, key) {
      return key in cache[__filename];
    },

    construct: function (target, args) {
      return Reflect.construct(cache[__filename], [...args]);
    },
    deleteProperty: function (target, key) {
      delete cache[__filename][key];
    },
    defineProperty: function (target, key, descriptor) {
      cache[__filename][key] = descriptor.value;
    },
    getOwnPropertyDescriptor: function (target, key) {
      return Object.getOwnPropertyDescriptor(cache[__filename], key);
    },

    getPrototypeOf(target) {
      return cache[__filename];
    },

    ownKeys: function (target) {
      return Object.keys(require(__filename));
    },

    apply(target, object, args) {
      return cache[__filename].apply(...args);
    }

  });
};