"use strict";

var _path = _interopRequireDefault(require("path"));

var _debug = _interopRequireDefault(require("debug"));

var _loadFiles = _interopRequireDefault(require("jinghuan-helper/loadFiles"));

var _each = _interopRequireDefault(require("lodash/each"));

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const log = (0, _debug.default)(`JH:core/loader/controller[${process.pid}]`);

function closure(filepath) {
  return function () {
    return require(filepath);
  };
}

function load() {
  const cache = {};
  (0, _each.default)(jinghuanjs.modulePaths, (loadPath, module) => {
    if (module === 'common') return;
    cache[module] = {};

    let dir = _path.default.join(loadPath, 'controller');

    const files = (0, _loadFiles.default)(dir, ['js', 'jsb']);

    for (let name in files) {
      let filepath = files[name];
      log(`load file: ${filepath}`);
      Object.defineProperty(cache[module], name, {
        get: closure(filepath)
      });
    }
  });
  return cache;
}

;
module.exports = load;