"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _each = _interopRequireDefault(require("lodash/each"));

var _loadFiles = _interopRequireDefault(require("jinghuan-helper/loadFiles"));

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const log = (0, _debug.default)(`JH:core/loader/events[${process.pid}]`);

function load() {
  let events = {};
  (0, _each.default)(jinghuanjs.modulePaths, (loadPath, module) => {
    if (module === 'common') return;

    let dir = _path.default.join(loadPath, 'events');

    let files = (0, _loadFiles.default)(dir, ['js', 'jsb']);
    (0, _each.default)(files, (file, name) => {
      let event = require(file);

      events[name] = events[name] || {};
      events[name][event.index] = event.handle;

      if (!jinghuanjs.events.isEvent(name)) {
        jinghuanjs.events.on(name, async (...args) => {
          for (let i in events[name]) {
            await events[name][i](...args);
          }
        });
      }
    });
  });
  return events;
}

;
var _default = load;
exports.default = _default;
module.exports = exports.default;