"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _middleware = _interopRequireDefault(require("./middleware"));

var _socket = _interopRequireDefault(require("./socket"));

var _extend = _interopRequireDefault(require("./extend"));

var _util = _interopRequireDefault(require("./util"));

var _events = _interopRequireDefault(require("./events"));

var _sql = _interopRequireDefault(require("./sql"));

var _validate = _interopRequireDefault(require("./validate"));

var _controller = _interopRequireDefault(require("./controller"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Loader {
  constructor() {}

  loadController() {
    return (0, _controller.default)();
  }

  loadMiddleware() {
    return _middleware.default.load();
  }

  loadSocket() {
    return _socket.default.load();
  }

  loadExtend(path) {
    return (0, _extend.default)(path);
  }

  loadEvents() {
    return (0, _events.default)();
  }

  loadSql() {
    return (0, _sql.default)();
  }

  loadValidate() {
    return (0, _validate.default)();
  }

}

Loader.extend = _util.default.extend;
var _default = Loader;
exports.default = _default;
module.exports = exports.default;