"use strict";

var _path = _interopRequireDefault(require("path"));

var _loadFiles = _interopRequireDefault(require("jinghuan-helper/loadFiles"));

var _debug = _interopRequireDefault(require("debug"));

var _each = _interopRequireDefault(require("lodash/each"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const log = (0, _debug.default)(`JH:core/loader/sql[${process.pid}]`);

function closure(filepath) {
  return function () {
    return require(filepath);
  };
}

function load() {
  const cache = {};
  (0, _each.default)(jinghuanjs.modulePaths, (loadPath, module) => {
    if (module === 'common') return;
    cache[module] = {};

    let dir = _path.default.join(loadPath, 'sql');

    const itemCache = (0, _loadFiles.default)(dir, ['sql']);

    for (let name in itemCache) {
      let filepath = itemCache[name];
      log(`load file: ${filepath}`);
      Object.defineProperty(cache[module], name, {
        get: closure(filepath)
      });
    }
  });
  return cache;
}

;
module.exports = load;