"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _keys = _interopRequireDefault(require("lodash/keys"));

var _remove = _interopRequireDefault(require("lodash/remove"));

var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Response {
  constructor() {
    this._headers = {};
  }

  setHeader(name, value) {
    this._headers[name] = value;
  }

  getHeader(name) {
    return this._headers[name];
  }

  getHeaderNames() {
    return (0, _keys.default)(this._headers);
  }

  getHeaders() {
    return this._headers;
  }

  hasHeader(name) {
    return !(0, _isEmpty.default)(this._headers[name]);
  }

  removeHeader(name) {
    delete this._headers[name];
  }

}

var _default = Response;
exports.default = _default;
module.exports = exports.default;