"use strict";

var _bluebird = _interopRequireDefault(require("bluebird"));

var _jinghuanLogger = _interopRequireDefault(require("jinghuan-logger"));

var _package = _interopRequireDefault(require("../package.json"));

var _jinghuanHelper = _interopRequireDefault(require("jinghuan-helper"));

var _events = _interopRequireDefault(require("./core/events"));

var _define = _interopRequireDefault(require("jinghuan-helper/define"));

var _jinghuanDb = _interopRequireDefault(require("jinghuan-db"));

var _jinghuanCache = _interopRequireDefault(require("jinghuan-cache"));

var _jinghuanTpl = _interopRequireDefault(require("jinghuan-tpl"));

var _get = _interopRequireDefault(require("lodash/get"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _utils = _interopRequireDefault(require("./utils"));

var _module = _interopRequireDefault(require("module"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const db = (0, _jinghuanDb.default)(function (name) {
  return jinghuanjs.config(`database.${name}`);
});
const cache = (0, _jinghuanCache.default)(function (name) {
  return jinghuanjs.config(`cache.${name}`);
});
const tpl = (0, _jinghuanTpl.default)(function (name) {
  return jinghuanjs.config(`tpl.${name}`);
});

class Controller {}

(0, _define.default)('Promise', _bluebird.default, global);
const jinghuanjs = {};
(0, _define.default)('jinghuanjs', jinghuanjs, global);
(0, _define.default)('jinghuan', jinghuanjs, global);
(0, _define.default)('helper', _jinghuanHelper.default, jinghuanjs);
(0, _define.default)('version', _package.default.version, jinghuanjs);
(0, _define.default)('tpl', tpl, jinghuanjs);
(0, _define.default)('Controller', Controller, jinghuanjs);
(0, _define.default)('logger', _jinghuanLogger.default, jinghuanjs);
(0, _define.default)('events', new _events.default(), jinghuanjs);
(0, _define.default)('db', db, jinghuanjs);
(0, _define.default)('cache', cache, jinghuanjs);
(0, _define.default)('get', _utils.default.find, jinghuanjs);
(0, _define.default)('registerTextHandler', function (type) {
  _module.default._extensions["." + type] = function (module, filename) {
    module.exports = _fsExtra.default.readFileSync(filename, {
      encoding: "utf8"
    });
  };
}, jinghuanjs);
(0, _define.default)('registerEmptyHandler', function (type) {
  _module.default._extensions["." + type] = function (module, filename) {
    module.exports = null;
  };
}, jinghuanjs);