"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isString = _interopRequireDefault(require("lodash/isString"));

var _isObject = _interopRequireDefault(require("lodash/isObject"));

var _get = _interopRequireDefault(require("lodash/get"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function requireResolve(name) {
  try {
    return require.resolve(name, {
      paths: jinghuanjs.paths
    });
  } catch (e) {
    return false;
  }
}

function find(name, ctx, def = null) {
  if ((0, _isString.default)(ctx)) {
    if ((0, _isObject.default)(jinghuan[name])) {
      return (0, _get.default)(jinghuan[name], ctx, def);
    }
  } else if ((0, _isObject.default)(ctx)) {
    if ((0, _isObject.default)(jinghuan[name])) {
      let {
        module,
        controller,
        action
      } = ctx;
      let ret = null;

      if (!ret) {
        ret = (0, _get.default)(jinghuan[name], `${module}.${controller}/${action}`);
      }

      if (!ret) {
        ret = (0, _get.default)(jinghuan[name], `${module}.${controller}.${action}`);
      }

      if (!ret) {
        ret = (0, _get.default)(jinghuan[name], `${module}.${controller}`);
      }

      return ret || def;
    }
  }

  return def;
}

var _default = {
  requireResolve,
  find
};
exports.default = _default;
module.exports = exports.default;